#include "amx.h"

extern int amx_fflush();

typedef struct tagFMTINFO {
  const cell *params;
  int numparams;
  int skip;     // number of characters to skip from the beginning
  int length;   // number of characters to print
  // helper functions
  int (*f_putstr)(void *dest,const char *);
  int (*f_putchar)(void *dest,char);
  void *user;   // user data
} AMX_FMTINFO;

int amx_printstring(AMX *amx,cell *cstr,AMX_FMTINFO *info);

static cell AMX_NATIVE_CALL n_printf(AMX *amx,const cell *params)
{
	cell *cstr;
	AMX_FMTINFO info;
	
	memset(&info,0,sizeof info);
	info.params=params+2;
	info.numparams=(int)(params[0]/sizeof(cell))-1;
	info.skip=0;
	info.length=INT_MAX;
	
#if defined PAWN4
	cstr = amx_Address(amx , params[1] );
#else
	amx_GetAddr(amx,params[1],&cstr);
#endif
	
	amx_printstring(amx,cstr,&info);
	
	amx_fflush();
	return 0;
}

#if defined FLOATPOINT
int AMXEXPORT amx_FloatInit(AMX *amx);
#endif

#if defined FIXEDPOINT
int AMXEXPORT amx_FixedInit(AMX *amx);
#endif
