/******************************************************************************
 *
 * boot_demo1.ld - Linker configuration file for boot_demo1.
 *
 * Copyright (c) 2008-2011 Texas Instruments Incorporated.  All rights reserved.
 * Software License Agreement
 * 
 * Texas Instruments (TI) is supplying this software for use solely and
 * exclusively on TI's microcontroller products. The software is owned by
 * TI and/or its suppliers, and is protected under applicable copyright
 * laws. You may not combine this software with "viral" open-source
 * software in order to form a larger program.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITH ALL FAULTS.
 * NO WARRANTIES, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING, BUT
 * NOT LIMITED TO, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE. TI SHALL NOT, UNDER ANY
 * CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL, OR CONSEQUENTIAL
 * DAMAGES, FOR ANY REASON WHATSOEVER.
 * 
 * This is part of revision 8555 of the EK-LM4F232 Firmware Package.
 *
 *****************************************************************************/

MEMORY
{
    FLASH (rx) : ORIGIN = 0x00000000, LENGTH = 0x00040000
    SRAM (rwx) : ORIGIN = 0x20000000, LENGTH = 0x00008000
}

SECTIONS
{
    .text :
    {
        _text = .;
        KEEP(*(.isr_vector))
        *(.text*)
        *(.rodata .rodata.* .gnu.linkonce.r.*)
        . = ALIGN(4);
        __init_array_start = .;
        KEEP (*(SORT(.init_array.*)))
        KEEP (*(.init_array))
        __init_array_end = .;
        _etext = .;
    } > FLASH
    
    .ARM.exidx :
    {
        *(.ARM.exidx* .gnu.linkonce.armexidx.*)
    } >FLASH
    
    .data : ALIGN(8)
    {
        _data = .;
        *(vtable)
        *(.data*)
        _edata = .;
    } > SRAM AT> FLASH

   .bss :
   {
       _bss = .;
       *(.bss*)
       *(COMMON)
       _ebss = .;
       . = ALIGN (8);
   } > SRAM

    STACK_SIZE = 24576;

    .stack : {
        PROVIDE( _STACK_END = . );
        . += STACK_SIZE;
        . = ALIGN (8);
        PROVIDE( _STACK_START = . );
    } >SRAM

}

PROVIDE(_lmadata = LOADADDR (.data));
PROVIDE( _HEAP_START = _STACK_START );
PROVIDE ( _HEAP_END = ALIGN(ORIGIN(SRAM) + LENGTH(SRAM) ,8) ); 

/*
STACK_SIZE = 16384;
*/